# File rvsao/Fquot/chiper.x
# January 21, 1993
# Converted to SPP by Doug Mink, Harvard-Smithsonian Center for Astrophysics
# After Paul Schecter
# Modified by Gerard Kriss, Johns Jopkins University

real procedure chiper (x,y,ye,unc,lo,lup,a,ae,nparam,nitera) 

real	x[ARB]
complex	y[ARB]
real	ye[1]
real	unc
real	a[3]
real	ae[nparam] 
int	nparam
int	nitera

complex	s[4096],cexp1()
complex	sarg
real	fr,fi,fa1r,fa1i,fa2r,fa2i,fa3r,fa3i
real	v[11],c[4,4],b[4,4] 
real	sig2,diffr,diffi,c1,c2
int	iexc[4096]
bool	conv
real	chiold,proj,fact,chi,perdeg
#real	det, simul()
int	npts,lo,lup,i,j,k,l,ifact,nfree

begin
	npts = 0
	do j = lo,lup {
	    npts = npts+1
	    iexc[j] = 0
	    }
	chiold = 0 
	sig2 = exp (2. * a[2] )
#	call printf ("CHIPER: a[1]= %f, a[2]= %f, a[3]= %f sig2= %f np= %d\n")
#		    call pargr (a[1])
#		    call pargr (a[2])
#		    call pargr (a[3])
#		    call pargr (sig2)
#		    call pargi (nparam)
	do j = lo,lup {
	    if (x[j] == 0.)
		s[j] = complex (1.,0.)
	    else
		c1 = x[j]**2 / 2. * sig2
		c2 = -x[j] * a[1]
		s[j] = a[3] * cexp1 (c1, c2)
#	    call printf ("CHIPER: j= %d, x[j]= %f c1= %f, c2= %f s[j]= %z\n")
#		    call pargi (j)
#		    call pargr (x[j])
#		    call pargr (c1)
#		    call pargr (c2)
#		    call pargx (s[j])
	    diffr = real(s[j]) - real(y[j])
	    diffi = aimag(s[j]) - aimag(y[j])
	    chiold = chiold + (diffr*diffr + diffi*diffi) / (ye[j]*ye[j])
	    }
 
	i = 0
	ifact = 0 
 
	call info (i, ifact, a, chiold, npts)
 
	do i = 1,nitera {

#  after two iterations, exclude extreme data points.
#  use i <= 2 for that option.
	    if (i > 2) {
		do j = lo,lup {
		    proj = real (y[j] * cexp1 (0.,x[j] * a[1]))
		    iexc[j] = 0
		    if (proj > 1.5) iexc[j] = 1
		    if (proj < -0.5) iexc[j] = 1
		    }

#  re-evaluate chiold
		chiold = 0.0
		npts = 0
		do j = lo,lup {
		    if (iexc[j] != 1) {
			s[j] = a[3] * cexp1 (x[j]**2/2.*sig2,-x[j]*a[1])
			chiold = chiold +
				 ((real(s[j])-real(y[j]))**2 +
				 (aimag(s[j])-aimag(y[j]))**2)/ye[j]**2
			npts = npts+1
			}
		    }
		}

	    do j = 1,4 {
		do k = 1,4 {
		    c[j,k] = 0.
		    }
		}

	    do j = lo, lup {
#		call printf ("CHIPER: i= %d, j= %d, iexc= %d\n")
#		    call pargi (i)
#		    call pargi (j)
#		    call pargi (iexc[j])
		if (iexc[j] != 1) {
		    fr = real (s[j] - y[j]) / ye[j]
		    fi = aimag (s[j] - y[j]) / ye[j]
		    sarg = s[j] / ye[j]
#		    call printf ("CHIPER: %d s= %z, y= %z, ye= %f\n")
#			call pargi (j)
#			call pargx (s[j])
#			call pargx (y[j])
#			call pargr (ye[j])
#		    call printf ("CHIPER: %d f= %f + %fi, sarg= %z, x= %f\n")
#			call pargi (j)
#			call pargr (fr)
#			call pargr (fi)
#			call pargx (sarg)
#			call pargr (x[j])
		    fa1r = x[j] * aimag(sarg)
		    fa1i = x[j] * -real(sarg)
		    fa2r = -(x[j]*x[j]) * sig2 * real (sarg)
		    fa2i = -(x[j]*x[j]) * sig2 * aimag (sarg)
		    fa3r = real (sarg) / a[3] 
		    fa3i = aimag (sarg) / a[3] 
#		    call printf ("CHIPER: %d fa1= %f + %fi, fa2= %f + %fi, fa3= %f + %fi\n")
#			call pargi (j)
#			call pargr (fa1r)
#			call pargr (fa1i)
#			call pargr (fa2r)
#			call pargr (fa2i)
#			call pargr (fa3r)
#			call pargr (fa3i)

		    c[1,4] = c[1,4] + (fr * fa1r) + (fi * fa1i)
		    c[2,4] = c[2,4] + (fr * fa2r) + (fi * fa2i)
		    c[3,4] = c[3,4] + (fr * fa3r) + (fi * fa3i)
		    c[3,3] = c[3,3] + (fa3r * fa3r) + (fa3i * fa3i)
		    c[2,3] = c[2,3] + (fa2r * fa3r) + (fa2i * fa3i)
		    c[1,3] = c[1,3] + (fa1r * fa3r) + (fa1i * fa3i)
		    c[2,2] = c[2,2] + (fa2r * fa2r) + (fa2i * fa2i)
		    c[1,2] = c[1,2] + (fa1r * fa2r) + (fa1i * fa2i)
		    c[1,1] = c[1,1] + (fa1r * fa1r) + (fa1i * fa1i)
		    }
		}

	    do k = 1,10 {
		conv = (k == 1) 
		if (k == 1) fact = 0 
		if (k != 1) fact = 2.**ifact 
		do j = 1, nparam {
		    do l = 1,j {
			b[l,j] = c[l,j] 
			b[j,l] = c[l,j] 
			}
		    b[j,nparam+1] = c[j,nparam+1] 
		    b[j,j] = (1+fact)*c[j,j] 
		    }
#		call printf ("CHIPER: b= %g %g %g %g\n")
#		    call pargr (b[1,1])
#		    call pargr (b[2,1])
#		    call pargr (b[3,1])
#		    call pargr (b[4,1])
#		call printf ("CHIPER: b= %g %g %g %g\n")
#		    call pargr (b[1,2])
#		    call pargr (b[2,2])
#		    call pargr (b[3,2])
#		    call pargr (b[4,2])
#		call printf ("CHIPER: b= %g %g %g %g\n")
#		    call pargr (b[1,3])
#		    call pargr (b[2,3])
#		    call pargr (b[3,3])
#		    call pargr (b[4,3])
#		call printf ("CHIPER: b= %g %g %g %g\n")
#		    call pargr (b[1,4])
#		    call pargr (b[2,4])
#		    call pargr (b[3,4])
#		    call pargr (b[4,4])

#		call printf ("CHIPER: b set up for k = %d\n")
#		    call pargi (k)
#		det = simul (nparam,b,v,1.e-10,0,4) 
#		call printf ("CHIPER: determinant = %g\n")
#		    call pargr (det)
#		call printf ("CHIPER: a= %f %f %f\n")
#		    call pargr (a[1])
#		    call pargr (a[2])
#		    call pargr (a[3])
#		call printf ("CHIPER: v= %f %f %f\n")
#		    call pargr (v[1])
#		    call pargr (v[2])
#		    call pargr (v[3])
		do j = 1, nparam {
		    a[j] = a[j] - v[j] 
		    if  ( a[j] ==  0. ) a[j] = 1.e-10
		    conv = conv && (abs(v[j]/a[j]) <= unc) 
		    }
		if (a[2] > 35.) a[2] = 35.
		if (a[2] < -35.) a[2] = -35.
		if (a[3] < 0.) a[3] = 0.01
		sig2 = exp( 2. * a[2] )
		chi = 0 
		if (!conv) {
		    do j = lo,lup {
			if (iexc[j] != 1) {
			    s[j] = a[3]*cexp1(x[j]**2/2.*sig2,-x[j]*a[1])
			    chi = chi +
			          ((real(s[j])-real(y[j]))**2 +
			          (aimag(s[j])-aimag(y[j]))**2)/ye[j]**2
			    }
			}
		    }
#		call printf ("CHIPER: chi = %g\n")
#		    call pargr (chi)
 
		if (k != 1) ifact = ifact-1 
		if  (ifact < -15)  ifact = -15
		if (chi < (1.0001*chiold)) break
		if (k != 1) ifact = ifact+2 
		if (ifact > 15) ifact = 15
		do j = 1,nparam {
		    a[j] = a[j] + v[j] 
		    if (a[j] == 0.) a[j] = 1.e-10
		    }
		}

	    if (chi >= (1.0001*chiold)) {
		if (a[2] > 35.) a[2] = 35.
		if (a[2] < -35.) a[2] = -35.
		if (a[3] < 0.) a[3] = 0.01
		sig2 = exp (2. * a[2])
		if (ifact > 10) break
		}
	    if (conv) break
	    if (chi < chiold) chiold = chi 
	    }

	nfree = npts - nparam 
	perdeg = chiold / nfree 
	do i = 1, nparam {
	    ae[i] = sqrt (perdeg * b[i,i]) 
	    if (ae[i] == 0.) ae[i] = 1.e-10
	    do j = 1,i {
		c[i,j] = perdeg * b[i,j] / ae[i] / ae[j] 
		}
	    }
 
	call info (i, ifact, a, perdeg, npts)
 
	return (perdeg)
end 
# Dec  3 1992	Converted from Fortran to SPP
